=== test/performance/io/CMakeLists.txt ===
seqan3_benchmark(stream_input_benchmark.cpp)
seqan3_benchmark(stream_output_benchmark.cpp)
seqan3_benchmark(format_fasta_benchmark.cpp)
seqan3_benchmark(format_vienna_benchmark.cpp)
