=== debian/changelog ===
seqan3 (3.0.0.0.git.20200110.b42671eac39-1) unstable; urgency=medium

  * Experimental snapshot from upstream
  * Try using the Debian package for range-v3

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Jan 2020 15:41:25 +0100
