=== test/performance/core/CMakeLists.txt ===
add_subdirectories ()
seqan3_benchmark(bit_manipulation_benchmark.cpp)
