=== test/performance/core/simd/CMakeLists.txt ===
seqan3_benchmark(simd_algorithm_benchmark.cpp)
seqan3_benchmark(view_to_simd_chunk_benchmark.cpp)
