=== test/unit/alphabet/structure/CMakeLists.txt ===
seqan3_test(dot_bracket3_test.cpp)
seqan3_test(dssp9_test.cpp)
seqan3_test(structured_aa_test.cpp)
seqan3_test(structured_rna_test.cpp)
seqan3_test(wuss_test.cpp)
