=== test/unit/std/concept/CMakeLists.txt ===
seqan3_test(core_language_test.cpp)
seqan3_test(comparison_test.cpp)
seqan3_test(object_test.cpp)
seqan3_test(callable_test.cpp)
seqan3_test(iterator_test.cpp)
seqan3_test(range_test.cpp)
