=== test/unit/alignment/matrix/detail/CMakeLists.txt ===
seqan3_test (aligned_sequence_builder_test.cpp)
seqan3_test (alignment_matrix_column_major_range_test.cpp)
seqan3_test (alignment_score_matrix_one_column_banded_test.cpp)
seqan3_test (alignment_score_matrix_one_column_test.cpp)
seqan3_test (alignment_trace_matrix_full_banded_test.cpp)
seqan3_test (alignment_trace_matrix_full_test.cpp)
seqan3_test (trace_iterator_banded_test.cpp)
seqan3_test (trace_iterator_test.cpp)
seqan3_test (two_dimensional_matrix_test.cpp)
